<?php

define( '_VALID_MOS', 1 );

include "../configuration.php";
include "../includes/joomla.php";
include "migrator.class.php";
include "legacy/class.migrator.php";
include 'language/english.php';

$database->setQuery("CREATE TABLE IF NOT EXISTS ndn_migrator_tasks (taskid INT(11) NOT NULL AUTO_INCREMENT, tablename VARCHAR(50) NOT NULL, start INT(11) NOT NULL, amount INT(11) NOT NULL, total INT(11) NOT NULL, PRIMARY KEY(taskid))");
$database->Query() or die($database->getErrorMsg());

start();
doTask();

$database->setQuery("drop table ndn_migrator_tasks");
$database->Query() or die($database->getErrorMsg());

// for migrating Joomla from 1.0.x to 1.5
// heavily hacked... don't ask for the details
//   Aaron 2008/02/04

function start() {
	global $mosConfig_absolute_path, $mosConfig_db, $mosConfig_dbprefix, $database;
	$SQLDump = new JFiler(1);
	if (!isset ($_SESSION['sql_file_time'])) {
		$_SESSION['sql_file_time'] = time();
		$sql_time = $_SESSION['sql_file_time'];
	} else {
		$sql_time = $_SESSION['sql_file_time'];
	}
	if (!isset ($_SESSION['sql_file'])) {
		// $sql_file = $mosConfig_db . "_" . strftime("%Y%m%d_%H%M%S", $sql_time) . '.sql';
		$sql_file = 'ndn_backup.sql';
		$_SESSION['sql_file'] = $sql_file;
		$filename = $mosConfig_absolute_path . "/ndn_joomla_migrator/" . $sql_file;
		
		if(!is_writable(dirname($filename)) || !$SQLDump->createFile( $filename )) {
			displayResource('unwriteable');
			return;
		}
		
		//makeHeaderTableDef($mosConfig_db, $sql_time, & $SQLDump, count($tables), $header_def, $dump_struct);
	} else {
		$sql_file = mosGetParam($_SESSION, 'sql_file');
		if(!$SQLDump->openFile($mosConfig_absolute_path . "/ndn_joomla_migrator/" . $sql_file)) {
			displayResource('unwriteable');
			return;
		}
	}
	$table_base_path = $mosConfig_absolute_path . "/ndn_joomla_migrator/tables/";
	if($tables = opendir($table_base_path)) {
		$tablelist = Array();
		while($entry = readdir($tables)) {
			if( $entry != "." && $entry != ".." && is_file($table_base_path.$entry)) {
				if(stristr($entry,'.sql') !== FALSE) {
					$tablelist[] = $entry;
				}
			}
		}
		sort($tablelist);
		foreach($tablelist as $entry) {
			$file = fopen($table_base_path.$entry,'r');
			$data = fread($file, filesize($table_base_path.$entry));
			$SQLDump->writeFile($data."\n");
			fclose($file);
		}

		closedir($tables);
	}
	
	$enumerator = new ETLEnumerator();
	$plugins = $enumerator->createPlugins();
	$tasks = new TaskBuilder($database, $plugins);
	$tasks->saveTaskList();
	$tasklist = new TaskList($database);
	$tasklist->listAll();
}

function doTask() {
	global $mosConfig_absolute_path, $mosConfig_db, $mosConfig_dbprefix, $database;
	$tasklist = new TaskList($database);
	if ($tasklist->countTasks()) {
		$SQLDump = new JFiler(1);
		if (!isset ($_SESSION['sql_file_time'])) {
			$_SESSION['sql_file_time'] = time();
			$sql_time = $_SESSION['sql_file_time'];
		} else {
			$sql_time = $_SESSION['sql_file_time'];
		}
		if (!isset ($_SESSION['sql_file'])) {
			// $sql_file = $mosConfig_db . "_" . strftime("%Y%m%d_%H%M%S", $sql_time) . '.sql';
			$sql_file = 'ndn_backup.sql';
			$_SESSION['sql_file'] = $sql_file;
			$SQLDump->createFile($mosConfig_absolute_path . "/ndn_joomla_migrator/" . $sql_file);
			//makeHeaderTableDef($mosConfig_db, $sql_time, & $SQLDump, count($tables), $header_def, $dump_struct);
		} else {
			$sql_file = mosGetParam($_SESSION, 'sql_file');
			$SQLDump->openFile($mosConfig_absolute_path . "/ndn_joomla_migrator/" . $sql_file);
		}
		while ($task = $tasklist->getNextTask()) {
			$task->execute($SQLDump);
		}
	}
	
	print "All DONE!!!\n";
}

?>
